classification
Title: add __iter__ to enum.Flag members
Type: enhancement Stage: needs patch
Components: Library (Lib) Versions: Python 3.10
process
Status: open Resolution:
Dependencies: Superseder:
Assigned To: ethan.furman Nosy List: Guy Gangemi, barry, eli.bendersky, ethan.furman, rhettinger
Priority: normal Keywords: patch

Created on 2017-12-05 03:44 by Guy Gangemi, last changed 2020-09-19 08:30 by ethan.furman.

Pull Requests
URL Status Linked Edit
PR 22221 merged ethan.furman, 2020-09-12 23:41
Messages (3)
msg307629 - (view) Author: Guy Gangemi (Guy Gangemi) Date: 2017-12-05 03:44
I'm proposing to extend enum.Flag member functionality so it is iterable in a manner similar to enum.Flag subclasses.

from enum import Flag, auto


class FlagIter(Flag):
    def __iter__(self):
        for memeber in self._member_map_.values():
            if member in self:
                yield member


class Colour(FlagIter):
    RED = auto()
    GREEN = auto()
    BLUE = auto()
    YELLOW = RED | GREEN

cyan = Colour.GREEN | Colour.Blue

print(*Colour)  # Colour.RED Colour.GREEN Colour.BLUE Colour.YELLOW

# Without the enhancement, 'not iterable' is thrown for these
print(*cyan)  # Colour.GREEN Colour.BLUE
print(*Colour.YELLOW)  # Colour.RED Colour.GREEN Colour.YELLOW
print(*~Colour.RED)  # Colour.GREEN Colour.BLUE
msg311204 - (view) Author: Ethan Furman (ethan.furman) * (Python committer) Date: 2018-01-30 00:29
This functionality is now in the third-party aenum* library.

Are there any strong use-cases for this behavior such that it should be in the stdlib?


* as of version 2.0.10, available on PyPI, and I am its author
msg377152 - (view) Author: Ethan Furman (ethan.furman) * (Python committer) Date: 2020-09-19 08:30
Problem:  What to do when the Flag has compound members?

    class Color(Flag):
        BLACK = 0
        RED = 1
        GREEN = 2
        BLUE = 4
        PURPLE = RED|BLUE
        WHITE = RED|GREEN|BLUE

I think the answer is: only return the single members.  So

  --> list(Color.WHITE)
  [Color.BLUE, Color.GREEN, Color.RED]
History
Date User Action Args
2020-09-19 08:30:17ethan.furmansetstatus: closed -> open
resolution: fixed ->
messages: + msg377152

stage: resolved -> needs patch
2020-09-17 08:23:54ethan.furmansetstatus: open -> closed
stage: patch review -> resolved
resolution: fixed
components: + Library (Lib)
versions: + Python 3.10, - Python 3.8
2020-09-12 23:41:50ethan.furmansetkeywords: + patch
stage: patch review
pull_requests: + pull_request21276
2018-01-30 00:29:57ethan.furmansetversions: + Python 3.8
nosy: + barry, rhettinger, eli.bendersky

messages: + msg311204

stage: needs patch -> (no value)
2018-01-18 19:31:45ethan.furmansetassignee: ethan.furman
stage: needs patch
2017-12-05 05:05:41berker.peksagsetnosy: + ethan.furman
2017-12-05 03:44:12Guy Gangemicreate